// @TOOD change this file name
<template>
  <div id="airship-type-form">

    <input type="text" v-model="airship_type_object.name" placeholder="name" />
    <button @click="CreateAirshipType">{{submit_text}}</button>

    <span id="error_message">{{error_message}}</span>
  </div>
</template>

<script>
import { setAuthorizationToken } from "../../utils/authUtils";
import { createDataBaseObject, putDataBaseObject, getAirshipTypeById } from "../../utils/apiUtils";
import router from "../../router";

const airship_type_url = "http://127.0.0.1:8000/handlings/airship_type/";

export default {
  name: "AirshipTypeCreate",
  props: {
    initial_object : Object,
    id : String,
    after_post_callback : Function
  },
  data: function() {
    return {
      airship_type_object:{
          name: ""
      },

      submit_text: "Create",
      error_message: ""
    };
  },
  methods: {
    AirshipTypeObjectClear() {
        this.airship_type_object = {
            name: ""
      };
    },
    CreateAirshipType() {
        (async () => {
            try {
              if (this.submit_text == "Create") {
                await createDataBaseObject(airship_type_url, this.airship_type_object, "airship_type");
                this.AirshipTypeObjectClear();
              } else if (this.submit_text == "Edit") {
                await putDataBaseObject(airship_type_url + this.id + "/", this.airship_type_object, "airship_type");
              }
              this.after_post_callback?.();
            } catch (error) {
                this.error_message = error;
            }
        })();
    },
    specChanged() {},
  },

  mounted: function() {
    if (this.initial_object) {
      this.airship_type_object = this.initial_object;
      this.submit_text = "Edit";
    }
    else if (this.id) {
      (async () => {
        setAuthorizationToken(localStorage.getItem("jwtAccessToken"));
        this.airship_type_object = await getAirshipTypeById(this.id);
      })();
      this.submit_text = "Edit";
    }
  }
};
</script>

<style scoped>
/* @TODO do something with this styles!!! - make it global or something */
#airship-type-form {
  font-family: Avenir, Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
  margin-left: 40%;
  margin-right: 40%;
}
input {
  width: 100%;
  padding: 12px 20px;
  margin: 8px 0;
  border: 1px solid #ccc;
  border-radius: 4px;
  box-sizing: border-box;
  text-align: center;
}
#error_message {
  color: red;
}
</style>>